/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* Copy the first part of user declarations.  */
#line 1 "mpsl.y" /* yacc.c:339  */

/*

    MPSL - Minimum Profit Scripting Language
    Copyright (C) 2003/2012 Angel Ortega <angel@triptico.com>

    mpsl.y - Minimum Profit Scripting Language YACC parser

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

    http://triptico.com

*/

#include <stdio.h>
#include <string.h>
#include <wchar.h>
#include "mpdm.h"
#include "mpsl.h"

/** data **/

/* the bytecode being generated */
static mpdm_t mpsl_bytecode = NULL;

/* pointer to source code being compiled */
extern wchar_t *mpsl_next_char;

/* pointer to file being compiled */
extern FILE *mpsl_file;

/* line number */
extern int mpsl_line;

/* compiled filename (for errors) */
static char *mpsl_filename = NULL;

/* cached value MPSL.OPCODE */
extern mpdm_t mpsl_opcodes;

/* cached value MPSL.LC */
extern mpdm_t mpsl_lc;


/** code **/

int yylex(void);
void yyerror(char *s);

#define INS0(o)             mpsl_mkins(o, 0, NULL, NULL, NULL, NULL)
#define INS1(o,a1)          mpsl_mkins(o, 1, a1, NULL, NULL, NULL)
#define INS2(o,a1,a2)       mpsl_mkins(o, 2, a1, a2, NULL, NULL)
#define INS3(o,a1,a2,a3)    mpsl_mkins(o, 3, a1, a2, a3, NULL)
#define INS4(o,a1,a2,a3,a4) mpsl_mkins(o, 4, a1, a2, a3, a4)

static mpdm_t mpsl_x(mpdm_t a1, mpdm_t a2, int sf)
/* creates an executable value with the MPSL executor as the first
   argument and a compiled stream as the second */
{
    return MPDM_X2(mpsl_exec_p,
                   mpsl_mkins(sf ? L"SUBFRAME" : L"BLKFRAME",
                              a2 == NULL ? 1 : 2, a1, a2, NULL, NULL));
}


static void compiler_warning(char *str)
{
    fprintf(stderr, "WARNING: %s.\n", str);
}



#line 151 "y.tab.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "y.tab.h".  */
#ifndef YY_YY_Y_TAB_H_INCLUDED
# define YY_YY_Y_TAB_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    NULLV = 258,
    INTEGER = 259,
    REAL = 260,
    STRING = 261,
    SYMBOL = 262,
    LITERAL = 263,
    WHILE = 264,
    FOR = 265,
    IF = 266,
    SUB = 267,
    FOREACH = 268,
    LOCAL = 269,
    GLOBAL = 270,
    BREAK = 271,
    RETURN = 272,
    IFI = 273,
    ELSE = 274,
    BOOLAND = 275,
    BOOLOR = 276,
    INC = 277,
    DEC = 278,
    IADD = 279,
    ISUB = 280,
    IMUL = 281,
    IDIV = 282,
    IMOD = 283,
    IBITAND = 284,
    IBITOR = 285,
    IBITXOR = 286,
    ISHR = 287,
    ISHL = 288,
    ORASSIGN = 289,
    IJOIN = 290,
    JOIN = 291,
    STREQ = 292,
    NUMEQ = 293,
    STRNE = 294,
    NUMNE = 295,
    NUMGE = 296,
    NUMLE = 297,
    ARROW = 298,
    RANGE = 299,
    AMPERSAND = 300,
    BITOR = 301,
    BITXOR = 302,
    SHL = 303,
    SHR = 304,
    MOD = 305,
    POW = 306,
    INVCALL = 307,
    UMINUS = 308
  };
#endif
/* Tokens.  */
#define NULLV 258
#define INTEGER 259
#define REAL 260
#define STRING 261
#define SYMBOL 262
#define LITERAL 263
#define WHILE 264
#define FOR 265
#define IF 266
#define SUB 267
#define FOREACH 268
#define LOCAL 269
#define GLOBAL 270
#define BREAK 271
#define RETURN 272
#define IFI 273
#define ELSE 274
#define BOOLAND 275
#define BOOLOR 276
#define INC 277
#define DEC 278
#define IADD 279
#define ISUB 280
#define IMUL 281
#define IDIV 282
#define IMOD 283
#define IBITAND 284
#define IBITOR 285
#define IBITXOR 286
#define ISHR 287
#define ISHL 288
#define ORASSIGN 289
#define IJOIN 290
#define JOIN 291
#define STREQ 292
#define NUMEQ 293
#define STRNE 294
#define NUMNE 295
#define NUMGE 296
#define NUMLE 297
#define ARROW 298
#define RANGE 299
#define AMPERSAND 300
#define BITOR 301
#define BITXOR 302
#define SHL 303
#define SHR 304
#define MOD 305
#define POW 306
#define INVCALL 307
#define UMINUS 308

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 86 "mpsl.y" /* yacc.c:355  */

	mpdm_t v;	/* a simple value */
	mpdm_t ins;	/* an 'instruction': [ opcode, args ] */

#line 302 "y.tab.c" /* yacc.c:355  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE yylval;

int yyparse (void);

#endif /* !YY_YY_Y_TAB_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 319 "y.tab.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  3
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   1702

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  72
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  10
/* YYNRULES -- Number of rules.  */
#define YYNRULES  98
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  239

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   308

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    36,     2,     2,     2,     2,     2,     2,
      63,    64,    56,    54,    67,    55,    69,    57,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    45,    62,
      48,    68,    47,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    70,     2,    71,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    65,     2,    66,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    37,    38,    39,    40,    41,    42,    43,    44,    46,
      49,    50,    51,    52,    53,    58,    59,    60,    61
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   113,   113,   117,   120,   124,   128,   133,   138,   143,
     148,   153,   159,   168,   178,   187,   199,   211,   217,   221,
     232,   236,   247,   251,   255,   262,   263,   270,   273,   281,
     285,   293,   296,   299,   305,   314,   318,   323,   328,   335,
     339,   343,   347,   351,   356,   362,   363,   364,   365,   366,
     367,   370,   371,   372,   373,   374,   377,   384,   393,   403,
     415,   421,   427,   433,   439,   445,   451,   457,   463,   469,
     476,   482,   489,   493,   497,   501,   505,   509,   513,   519,
     523,   527,   533,   537,   542,   547,   553,   558,   562,   566,
     572,   576,   581,   585,   589,   593,   597,   601,   605
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "NULLV", "INTEGER", "REAL", "STRING",
  "SYMBOL", "LITERAL", "WHILE", "FOR", "IF", "SUB", "FOREACH", "LOCAL",
  "GLOBAL", "BREAK", "RETURN", "IFI", "ELSE", "BOOLAND", "BOOLOR", "INC",
  "DEC", "IADD", "ISUB", "IMUL", "IDIV", "IMOD", "IBITAND", "IBITOR",
  "IBITXOR", "ISHR", "ISHL", "ORASSIGN", "IJOIN", "'!'", "JOIN", "STREQ",
  "NUMEQ", "STRNE", "NUMNE", "NUMGE", "NUMLE", "ARROW", "':'", "RANGE",
  "'>'", "'<'", "AMPERSAND", "BITOR", "BITXOR", "SHL", "SHR", "'+'", "'-'",
  "'*'", "'/'", "MOD", "POW", "INVCALL", "UMINUS", "';'", "'('", "')'",
  "'{'", "'}'", "','", "'='", "'.'", "'['", "']'", "$accept", "program",
  "function", "stmt", "stmt_list", "list", "sym_list", "hash", "compsym",
  "expr", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,    33,   291,   292,   293,
     294,   295,   296,   297,   298,    58,   299,    62,    60,   300,
     301,   302,   303,   304,    43,    45,    42,    47,   305,   306,
     307,   308,    59,    40,    41,   123,   125,    44,    61,    46,
      91,    93
};
# endif

#define YYPACT_NINF -76

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-76)))

#define YYTABLE_NINF -1

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
     -76,     8,   548,   -76,   -76,   -76,   -76,   -76,   -76,   -46,
     -23,   -21,    -5,    -6,    52,    54,     1,   602,    58,    58,
     830,    58,   830,   -76,   830,   232,   163,   -76,   548,   963,
    1286,   830,   624,   830,   110,   548,   -59,     6,    57,   -24,
      62,    44,   -76,   -40,   -76,   678,  1329,    38,    38,  1642,
     -54,   -76,   997,    98,   -76,   260,     0,  1243,   -76,   -64,
    1544,   -76,   -76,   -76,   830,   830,   830,   830,   830,   830,
     830,   830,   830,   830,   830,   830,   700,   830,    37,   830,
     830,   830,   830,   830,   830,   830,   830,   830,   830,   830,
     830,   830,   830,   830,   830,   830,   830,   830,   830,   830,
     830,   830,    58,   -76,  1038,    83,  1372,  1079,   -76,   -33,
     328,    -2,   548,    58,    51,   830,   -76,   141,   830,   -76,
    1568,   -76,   754,   -76,   830,   -76,   -76,   852,   830,   830,
     -76,   830,  1642,  1642,  1642,  1642,  1642,  1642,  1642,  1642,
    1642,  1642,  1642,  1642,   -76,    60,  1618,  1618,   -76,   -76,
     888,  1642,  1642,   950,   950,   950,   950,   950,   950,   950,
     950,   950,   105,   922,   922,    -4,    -4,    56,    56,    90,
      90,    90,    90,   -51,   548,    87,   830,   548,    88,   -76,
     106,    74,   356,    67,   830,  1415,   -76,  1458,   -76,    75,
    1618,   107,  1593,  1618,  1618,   913,   -76,   -76,   776,   -76,
     548,  1501,   154,   548,   548,   109,   -76,   830,  1120,   -76,
     -76,   -76,   830,   830,   -76,   -76,    80,   -76,   830,   548,
     424,   452,   548,  1161,   548,  1618,  1618,   -76,  1202,   -76,
     -76,   -76,   520,   548,   -76,   548,   -76,   -76,   -76
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       4,     0,     2,     1,    43,    39,    41,    40,    35,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     5,     0,     0,     0,    25,     3,    42,
       0,     0,     0,     0,     0,     0,     0,     0,    29,     0,
      29,     0,    22,     0,    24,     0,     0,    56,    57,    72,
       0,    44,     0,    35,    90,     0,     0,     0,    87,     0,
      27,    26,    58,    59,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     6,     0,     0,     0,     0,    29,     0,
       0,     0,     0,     0,     0,     0,    18,     0,     0,    20,
       0,    23,     0,    86,     0,    17,    91,     0,     0,     0,
      88,     0,    60,    61,    62,    63,    64,    65,    66,    67,
      69,    68,    70,    71,    92,     0,    27,    98,    36,    37,
       0,    82,    83,    79,    80,    77,    81,    78,    76,    75,
      74,    73,    51,    52,    53,    54,    55,    45,    46,    47,
      48,    49,    50,     0,     0,     0,     0,     0,     0,    84,
       0,     0,     0,     0,     0,     0,    30,     0,    96,     0,
      32,    35,     0,    31,    28,     0,    93,    38,     0,     7,
       0,     0,    10,     0,     0,     0,    12,     0,     0,    19,
      21,    97,     0,     0,    89,    94,     0,     9,     0,     0,
       0,     0,     0,     0,     0,    34,    33,    95,     0,    11,
      85,    13,     0,     0,    15,     0,    14,    16,     8
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int8 yypgoto[] =
{
     -76,   -76,   -76,   -28,    -3,   -75,    -1,   -76,    27,     4
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int8 yydefgoto[] =
{
      -1,     1,     2,    27,    28,    59,    39,    56,    29,    30
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_uint8 yytable[] =
{
      61,   145,     8,   129,   111,   108,   112,   130,     3,   122,
      78,    79,   198,     8,    41,    78,    79,    31,    78,    79,
     113,    46,    55,    34,    49,    35,    51,    61,    52,    57,
      60,   178,   110,   109,   117,   104,   106,   107,   116,    36,
      32,   148,    33,   117,   149,    47,    48,   189,    50,   120,
      96,    97,    98,    99,   100,   101,   102,    37,    34,    38,
      35,    40,   180,    42,   114,     8,   126,   127,   132,   133,
     134,   135,   136,   137,   138,   139,   140,   141,   142,   143,
     146,   147,    61,   150,   151,   152,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,   163,   164,   165,   166,
     167,   168,   169,   170,   171,   172,   119,    78,    79,   182,
     181,   117,    98,    99,   100,   101,   102,   108,   184,   185,
      78,    79,   187,   216,   196,   115,   146,   129,   190,   173,
     118,   192,   193,   194,   207,   195,    78,    79,   205,   211,
     183,   117,   129,   124,   227,   175,   199,   129,   186,   202,
     102,   200,   212,   203,    61,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,     4,     5,     6,     7,
       8,   204,   217,   219,   222,    43,     0,     0,     0,     0,
     201,     0,     0,     0,     0,    18,    19,     0,   208,     0,
       0,   229,    61,    61,     0,     0,   234,     0,     0,    20,
     220,   221,   146,     0,    61,   237,     0,   238,     0,     0,
       0,   223,    21,     0,     0,     0,   225,   226,    22,   232,
       0,     0,   228,     0,     0,     0,    24,     0,    45,     0,
       0,     0,     0,    26,    58,     4,     5,     6,     7,    53,
       0,     9,    10,    11,    12,    13,    14,    15,    16,    17,
       0,     0,     0,     0,    18,    19,     0,     0,     0,     0,
       0,     0,     0,     4,     5,     6,     7,     8,    20,     9,
      10,    11,    12,    13,    14,    15,    16,    17,     0,     0,
       0,    21,    18,    19,     0,     0,     0,    22,     0,     0,
       0,     0,     0,     0,    23,    24,    20,    25,    54,     0,
       0,     0,    26,     0,     0,     0,     0,     0,     0,    21,
       0,     0,     0,     0,     0,    22,     0,     0,     0,     0,
       0,     0,    23,    24,     0,    25,   125,     0,     0,     0,
      26,     4,     5,     6,     7,     8,     0,     9,    10,    11,
      12,    13,    14,    15,    16,    17,     0,     0,     0,     0,
      18,    19,     0,     0,     0,     0,     0,     0,     0,     4,
       5,     6,     7,     8,    20,     9,    10,    11,    12,    13,
      14,    15,    16,    17,     0,     0,     0,    21,    18,    19,
       0,     0,     0,    22,     0,     0,     0,     0,     0,     0,
      23,    24,    20,    25,   179,     0,     0,     0,    26,     0,
       0,     0,     0,     0,     0,    21,     0,     0,     0,     0,
       0,    22,     0,     0,     0,     0,     0,     0,    23,    24,
       0,    25,   206,     0,     0,     0,    26,     4,     5,     6,
       7,     8,     0,     9,    10,    11,    12,    13,    14,    15,
      16,    17,     0,     0,     0,     0,    18,    19,     0,     0,
       0,     0,     0,     0,     0,     4,     5,     6,     7,     8,
      20,     9,    10,    11,    12,    13,    14,    15,    16,    17,
       0,     0,     0,    21,    18,    19,     0,     0,     0,    22,
       0,     0,     0,     0,     0,     0,    23,    24,    20,    25,
     230,     0,     0,     0,    26,     0,     0,     0,     0,     0,
       0,    21,     0,     0,     0,     0,     0,    22,     0,     0,
       0,     0,     0,     0,    23,    24,     0,    25,   231,     0,
       0,     0,    26,     4,     5,     6,     7,     8,     0,     9,
      10,    11,    12,    13,    14,    15,    16,    17,     0,     0,
       0,     0,    18,    19,     0,     0,     0,     0,     0,     0,
       0,     4,     5,     6,     7,     8,    20,     9,    10,    11,
      12,    13,    14,    15,    16,    17,     0,     0,     0,    21,
      18,    19,     0,     0,     0,    22,     0,     0,     0,     0,
       0,     0,    23,    24,    20,    25,   236,     0,     0,     0,
      26,     0,     0,     0,     0,     0,     0,    21,     0,     0,
       0,     0,     0,    22,     0,     4,     5,     6,     7,     8,
      23,    24,     0,    25,    43,     0,     0,     0,    26,     0,
       0,     0,     0,     0,    18,    19,     0,     4,     5,     6,
       7,     8,     0,     0,     0,     0,    43,     0,    20,     0,
       0,     0,     0,     0,     0,     0,    18,    19,     0,     0,
       0,    21,     0,     0,     0,     0,     0,    22,     0,     0,
      20,     0,     0,     0,    44,    24,     0,    45,     0,     0,
       0,     0,    26,    21,     0,     0,     0,     0,     0,    22,
       0,     4,     5,     6,     7,    53,   105,    24,     0,    45,
      43,     0,     0,     0,    26,     0,     0,     0,     0,     0,
      18,    19,     0,     4,     5,     6,     7,     8,     0,     0,
       0,     0,    43,     0,    20,     0,     0,     0,     0,     0,
       0,     0,    18,    19,     0,     0,     0,    21,     0,     0,
       0,     0,     0,    22,     0,     0,    20,     0,     0,     0,
       0,    24,     0,    45,    54,     0,     0,     0,    26,    21,
       0,     0,     0,     0,     0,    22,     0,     4,     5,     6,
       7,     8,     0,    24,   144,    45,    43,     0,     0,     0,
      26,     0,     0,     0,     0,     0,    18,    19,     0,     4,
       5,     6,     7,     8,     0,     0,     0,     0,    43,     0,
      20,     0,     0,     0,     0,     0,     0,     0,    18,    19,
       0,     0,     0,    21,     0,     0,     0,     0,     0,    22,
       0,     0,    20,     0,     0,     0,     0,    24,   188,    45,
       0,     0,     0,     0,    26,    21,     0,     0,     0,     0,
       0,    22,     0,     4,     5,     6,     7,     8,     0,    24,
     215,    45,    43,     0,     0,     0,    26,     0,     0,     0,
       0,     0,    18,    19,     0,     4,     5,     6,     7,   191,
       0,     0,     0,     0,    43,     0,    20,     0,     0,     0,
       0,     0,     0,     0,    18,    19,     0,     0,     0,    21,
       0,     0,     0,     0,     0,    22,     0,     0,    20,     0,
       0,     0,     0,    24,     0,    45,     0,     0,     0,     0,
      26,    21,     0,     0,     0,     0,     0,    22,    80,    81,
       0,     0,     0,     0,     0,    24,     0,    45,     0,     0,
       0,     0,    26,     0,     0,    82,    83,    84,    85,    86,
      87,    88,     0,    80,    81,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,     0,
      82,    83,    84,    85,    86,    87,    88,     0,     0,   197,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    94,    95,    96,    97,    98,    99,
     100,   101,   102,     0,   214,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,     0,     0,     0,     0,     0,     0,    80,    81,     0,
       0,     0,     0,     0,     0,     0,    76,     0,     0,     0,
       0,    77,    78,    79,    82,    83,    84,    85,    86,    87,
      88,     0,     0,     0,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    80,    81,
       0,   123,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    82,    83,    84,    85,    86,
      87,    88,     0,     0,     0,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,    80,
      81,     0,   174,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    82,    83,    84,    85,
      86,    87,    88,     0,     0,     0,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      80,    81,     0,   177,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    82,    83,    84,
      85,    86,    87,    88,     0,     0,     0,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,    80,    81,     0,   224,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    82,    83,
      84,    85,    86,    87,    88,     0,     0,     0,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,    80,    81,     0,   233,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    82,
      83,    84,    85,    86,    87,    88,     0,     0,     0,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,    80,    81,     0,   235,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      82,    83,    84,    85,    86,    87,    88,   128,     0,     0,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,     0,   103,    80,    81,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    82,    83,    84,    85,    86,    87,    88,
       0,     0,     0,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,     0,   103,    80,
      81,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    82,    83,    84,    85,
      86,    87,    88,     0,     0,     0,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
       0,   121,    80,    81,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    82,
      83,    84,    85,    86,    87,    88,     0,     0,     0,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,     0,   176,    80,    81,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    82,    83,    84,    85,    86,    87,    88,     0,
       0,     0,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,     0,   209,    80,    81,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    82,    83,    84,    85,    86,
      87,    88,     0,     0,     0,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,     0,
     210,    80,    81,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    82,    83,
      84,    85,    86,    87,    88,     0,     0,     0,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,     0,   218,    80,    81,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    82,    83,    84,    85,    86,    87,    88,    80,    81,
     131,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,    82,    83,    84,    85,    86,
      87,    88,   128,    80,    81,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,     0,
      82,    83,    84,    85,    86,    87,    88,   213,    80,    81,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,     0,    82,    83,    84,    85,    86,
      87,    88,     0,     0,     0,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,    82,
      83,    84,    85,    86,    87,    88,     0,     0,     0,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102
};

static const yytype_int16 yycheck[] =
{
      28,    76,     7,    67,    63,     7,    65,    71,     0,    63,
      69,    70,    63,     7,    15,    69,    70,    63,    69,    70,
      14,    17,    25,    63,    20,    65,    22,    55,    24,    25,
      26,    64,    35,    34,    67,    31,    32,    33,    62,    12,
      63,     4,    63,    67,     7,    18,    19,   122,    21,    45,
      54,    55,    56,    57,    58,    59,    60,    63,    63,     7,
      65,     7,    64,    62,    37,     7,    66,    67,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,   110,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,    62,    69,    70,   112,
     111,    67,    56,    57,    58,    59,    60,     7,    67,   115,
      69,    70,   118,   198,    64,    68,   122,    67,   124,   102,
      68,   127,   128,   129,    67,   131,    69,    70,    64,    64,
     113,    67,    67,    45,    64,    62,   174,    67,     7,   177,
      60,    64,    45,    65,   182,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,     3,     4,     5,     6,
       7,    65,   200,    19,    65,    12,    -1,    -1,    -1,    -1,
     176,    -1,    -1,    -1,    -1,    22,    23,    -1,   184,    -1,
      -1,   219,   220,   221,    -1,    -1,   224,    -1,    -1,    36,
     203,   204,   198,    -1,   232,   233,    -1,   235,    -1,    -1,
      -1,   207,    49,    -1,    -1,    -1,   212,   213,    55,   222,
      -1,    -1,   218,    -1,    -1,    -1,    63,    -1,    65,    -1,
      -1,    -1,    -1,    70,    71,     3,     4,     5,     6,     7,
      -1,     9,    10,    11,    12,    13,    14,    15,    16,    17,
      -1,    -1,    -1,    -1,    22,    23,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,     3,     4,     5,     6,     7,    36,     9,
      10,    11,    12,    13,    14,    15,    16,    17,    -1,    -1,
      -1,    49,    22,    23,    -1,    -1,    -1,    55,    -1,    -1,
      -1,    -1,    -1,    -1,    62,    63,    36,    65,    66,    -1,
      -1,    -1,    70,    -1,    -1,    -1,    -1,    -1,    -1,    49,
      -1,    -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,    -1,
      -1,    -1,    62,    63,    -1,    65,    66,    -1,    -1,    -1,
      70,     3,     4,     5,     6,     7,    -1,     9,    10,    11,
      12,    13,    14,    15,    16,    17,    -1,    -1,    -1,    -1,
      22,    23,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     3,
       4,     5,     6,     7,    36,     9,    10,    11,    12,    13,
      14,    15,    16,    17,    -1,    -1,    -1,    49,    22,    23,
      -1,    -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,    -1,
      62,    63,    36,    65,    66,    -1,    -1,    -1,    70,    -1,
      -1,    -1,    -1,    -1,    -1,    49,    -1,    -1,    -1,    -1,
      -1,    55,    -1,    -1,    -1,    -1,    -1,    -1,    62,    63,
      -1,    65,    66,    -1,    -1,    -1,    70,     3,     4,     5,
       6,     7,    -1,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    -1,    -1,    -1,    -1,    22,    23,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     3,     4,     5,     6,     7,
      36,     9,    10,    11,    12,    13,    14,    15,    16,    17,
      -1,    -1,    -1,    49,    22,    23,    -1,    -1,    -1,    55,
      -1,    -1,    -1,    -1,    -1,    -1,    62,    63,    36,    65,
      66,    -1,    -1,    -1,    70,    -1,    -1,    -1,    -1,    -1,
      -1,    49,    -1,    -1,    -1,    -1,    -1,    55,    -1,    -1,
      -1,    -1,    -1,    -1,    62,    63,    -1,    65,    66,    -1,
      -1,    -1,    70,     3,     4,     5,     6,     7,    -1,     9,
      10,    11,    12,    13,    14,    15,    16,    17,    -1,    -1,
      -1,    -1,    22,    23,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,     3,     4,     5,     6,     7,    36,     9,    10,    11,
      12,    13,    14,    15,    16,    17,    -1,    -1,    -1,    49,
      22,    23,    -1,    -1,    -1,    55,    -1,    -1,    -1,    -1,
      -1,    -1,    62,    63,    36,    65,    66,    -1,    -1,    -1,
      70,    -1,    -1,    -1,    -1,    -1,    -1,    49,    -1,    -1,
      -1,    -1,    -1,    55,    -1,     3,     4,     5,     6,     7,
      62,    63,    -1,    65,    12,    -1,    -1,    -1,    70,    -1,
      -1,    -1,    -1,    -1,    22,    23,    -1,     3,     4,     5,
       6,     7,    -1,    -1,    -1,    -1,    12,    -1,    36,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    -1,    -1,
      -1,    49,    -1,    -1,    -1,    -1,    -1,    55,    -1,    -1,
      36,    -1,    -1,    -1,    62,    63,    -1,    65,    -1,    -1,
      -1,    -1,    70,    49,    -1,    -1,    -1,    -1,    -1,    55,
      -1,     3,     4,     5,     6,     7,    62,    63,    -1,    65,
      12,    -1,    -1,    -1,    70,    -1,    -1,    -1,    -1,    -1,
      22,    23,    -1,     3,     4,     5,     6,     7,    -1,    -1,
      -1,    -1,    12,    -1,    36,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    22,    23,    -1,    -1,    -1,    49,    -1,    -1,
      -1,    -1,    -1,    55,    -1,    -1,    36,    -1,    -1,    -1,
      -1,    63,    -1,    65,    66,    -1,    -1,    -1,    70,    49,
      -1,    -1,    -1,    -1,    -1,    55,    -1,     3,     4,     5,
       6,     7,    -1,    63,    64,    65,    12,    -1,    -1,    -1,
      70,    -1,    -1,    -1,    -1,    -1,    22,    23,    -1,     3,
       4,     5,     6,     7,    -1,    -1,    -1,    -1,    12,    -1,
      36,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,
      -1,    -1,    -1,    49,    -1,    -1,    -1,    -1,    -1,    55,
      -1,    -1,    36,    -1,    -1,    -1,    -1,    63,    64,    65,
      -1,    -1,    -1,    -1,    70,    49,    -1,    -1,    -1,    -1,
      -1,    55,    -1,     3,     4,     5,     6,     7,    -1,    63,
      64,    65,    12,    -1,    -1,    -1,    70,    -1,    -1,    -1,
      -1,    -1,    22,    23,    -1,     3,     4,     5,     6,     7,
      -1,    -1,    -1,    -1,    12,    -1,    36,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    -1,    -1,    -1,    49,
      -1,    -1,    -1,    -1,    -1,    55,    -1,    -1,    36,    -1,
      -1,    -1,    -1,    63,    -1,    65,    -1,    -1,    -1,    -1,
      70,    49,    -1,    -1,    -1,    -1,    -1,    55,    20,    21,
      -1,    -1,    -1,    -1,    -1,    63,    -1,    65,    -1,    -1,
      -1,    -1,    70,    -1,    -1,    37,    38,    39,    40,    41,
      42,    43,    -1,    20,    21,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    -1,
      37,    38,    39,    40,    41,    42,    43,    -1,    -1,    71,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    -1,    71,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    63,    -1,    -1,    -1,
      -1,    68,    69,    70,    37,    38,    39,    40,    41,    42,
      43,    -1,    -1,    -1,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    20,    21,
      -1,    64,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    37,    38,    39,    40,    41,
      42,    43,    -1,    -1,    -1,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    20,
      21,    -1,    64,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    39,    40,
      41,    42,    43,    -1,    -1,    -1,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      20,    21,    -1,    64,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    39,
      40,    41,    42,    43,    -1,    -1,    -1,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    20,    21,    -1,    64,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,
      39,    40,    41,    42,    43,    -1,    -1,    -1,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    20,    21,    -1,    64,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    39,    40,    41,    42,    43,    -1,    -1,    -1,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    20,    21,    -1,    64,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      37,    38,    39,    40,    41,    42,    43,    44,    -1,    -1,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    -1,    62,    20,    21,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    37,    38,    39,    40,    41,    42,    43,
      -1,    -1,    -1,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    -1,    62,    20,
      21,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    39,    40,
      41,    42,    43,    -1,    -1,    -1,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      -1,    62,    20,    21,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      38,    39,    40,    41,    42,    43,    -1,    -1,    -1,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    -1,    62,    20,    21,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    37,    38,    39,    40,    41,    42,    43,    -1,
      -1,    -1,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    -1,    62,    20,    21,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    37,    38,    39,    40,    41,
      42,    43,    -1,    -1,    -1,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    -1,
      62,    20,    21,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    38,
      39,    40,    41,    42,    43,    -1,    -1,    -1,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    -1,    62,    20,    21,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    37,    38,    39,    40,    41,    42,    43,    20,    21,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    37,    38,    39,    40,    41,
      42,    43,    44,    20,    21,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    -1,
      37,    38,    39,    40,    41,    42,    43,    44,    20,    21,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    -1,    37,    38,    39,    40,    41,
      42,    43,    -1,    -1,    -1,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    37,
      38,    39,    40,    41,    42,    43,    -1,    -1,    -1,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,    73,    74,     0,     3,     4,     5,     6,     7,     9,
      10,    11,    12,    13,    14,    15,    16,    17,    22,    23,
      36,    49,    55,    62,    63,    65,    70,    75,    76,    80,
      81,    63,    63,    63,    63,    65,    80,    63,     7,    78,
       7,    78,    62,    12,    62,    65,    81,    80,    80,    81,
      80,    81,    81,     7,    66,    76,    79,    81,    71,    77,
      81,    75,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    63,    68,    69,    70,
      20,    21,    37,    38,    39,    40,    41,    42,    43,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    62,    81,    62,    81,    81,     7,    78,
      76,    63,    65,    14,    80,    68,    62,    67,    68,    62,
      81,    62,    63,    64,    45,    66,    66,    67,    44,    67,
      71,    46,    81,    81,    81,    81,    81,    81,    81,    81,
      81,    81,    81,    81,    64,    77,    81,    81,     4,     7,
      81,    81,    81,    81,    81,    81,    81,    81,    81,    81,
      81,    81,    81,    81,    81,    81,    81,    81,    81,    81,
      81,    81,    81,    80,    64,    62,    62,    64,    64,    66,
      64,    78,    76,    80,    67,    81,     7,    81,    64,    77,
      81,     7,    81,    81,    81,    81,    64,    71,    63,    75,
      64,    81,    75,    65,    65,    64,    66,    67,    81,    62,
      62,    64,    45,    44,    71,    64,    77,    75,    62,    19,
      76,    76,    65,    81,    64,    81,    81,    64,    81,    75,
      66,    66,    76,    64,    75,    64,    66,    75,    75
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    72,    73,    74,    74,    75,    75,    75,    75,    75,
      75,    75,    75,    75,    75,    75,    75,    75,    75,    75,
      75,    75,    75,    75,    75,    76,    76,    77,    77,    78,
      78,    79,    79,    79,    79,    80,    80,    80,    80,    81,
      81,    81,    81,    81,    81,    81,    81,    81,    81,    81,
      81,    81,    81,    81,    81,    81,    81,    81,    81,    81,
      81,    81,    81,    81,    81,    81,    81,    81,    81,    81,
      81,    81,    81,    81,    81,    81,    81,    81,    81,    81,
      81,    81,    81,    81,    81,    81,    81,    81,    81,    81,
      81,    81,    81,    81,    81,    81,    81,    81,    81
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     2,     0,     1,     2,     5,     9,     6,
       5,     7,     5,     7,     8,     7,     8,     3,     3,     5,
       3,     5,     2,     3,     2,     1,     2,     1,     3,     1,
       3,     3,     3,     5,     5,     1,     3,     3,     4,     1,
       1,     1,     1,     1,     2,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     2,     2,     2,     2,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     2,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     4,     7,     3,     2,     3,     5,
       2,     3,     3,     4,     5,     6,     4,     5,     3
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                                              );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);

        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 113 "mpsl.y" /* yacc.c:1646  */
    { ; }
#line 1841 "y.tab.c" /* yacc.c:1646  */
    break;

  case 3:
#line 117 "mpsl.y" /* yacc.c:1646  */
    {
					mpsl_bytecode = (yyvsp[0].ins);
				}
#line 1849 "y.tab.c" /* yacc.c:1646  */
    break;

  case 5:
#line 124 "mpsl.y" /* yacc.c:1646  */
    {
					/* null instruction */
					(yyval.ins) = INS0(L"MULTI");
				}
#line 1858 "y.tab.c" /* yacc.c:1646  */
    break;

  case 6:
#line 128 "mpsl.y" /* yacc.c:1646  */
    {
					/* expression, as is */
					(yyval.ins) = (yyvsp[-1].ins);
				}
#line 1867 "y.tab.c" /* yacc.c:1646  */
    break;

  case 7:
#line 134 "mpsl.y" /* yacc.c:1646  */
    {
					/* while loop */
					(yyval.ins) = INS2(L"WHILE", (yyvsp[-2].ins), (yyvsp[0].ins));
				}
#line 1876 "y.tab.c" /* yacc.c:1646  */
    break;

  case 8:
#line 139 "mpsl.y" /* yacc.c:1646  */
    {
                    /* for loop */
                    (yyval.ins) = INS4(L"WHILE", (yyvsp[-4].ins), (yyvsp[0].ins), (yyvsp[-6].ins), (yyvsp[-2].ins));
                }
#line 1885 "y.tab.c" /* yacc.c:1646  */
    break;

  case 9:
#line 144 "mpsl.y" /* yacc.c:1646  */
    {
                    /* infinite loop */
                    (yyval.ins) = INS2(L"WHILE", INS1(L"LITERAL", MPDM_I(1)), (yyvsp[0].ins));
                }
#line 1894 "y.tab.c" /* yacc.c:1646  */
    break;

  case 10:
#line 149 "mpsl.y" /* yacc.c:1646  */
    {
					/* if - then construction */
					(yyval.ins) = INS2(L"IF", (yyvsp[-2].ins), (yyvsp[0].ins));
				}
#line 1903 "y.tab.c" /* yacc.c:1646  */
    break;

  case 11:
#line 154 "mpsl.y" /* yacc.c:1646  */
    {
					/* if - then - else construction */
					(yyval.ins) = INS3(L"IF", (yyvsp[-4].ins), (yyvsp[-2].ins), (yyvsp[0].ins));
				}
#line 1912 "y.tab.c" /* yacc.c:1646  */
    break;

  case 12:
#line 160 "mpsl.y" /* yacc.c:1646  */
    {
					/* subroutine definition,
					   without arguments */
					(yyval.ins) = INS2(L"ASSIGN", (yyvsp[-3].ins),
						INS1(L"LITERAL",
							mpsl_x((yyvsp[-1].ins), NULL, 1)));
				}
#line 1924 "y.tab.c" /* yacc.c:1646  */
    break;

  case 13:
#line 169 "mpsl.y" /* yacc.c:1646  */
    {
					/* subroutine definition,
					   without arguments (second
					   syntax, including parens) */
					(yyval.ins) = INS2(L"ASSIGN", (yyvsp[-5].ins),
						INS1(L"LITERAL",
							mpsl_x((yyvsp[-1].ins), NULL, 1)));
				}
#line 1937 "y.tab.c" /* yacc.c:1646  */
    break;

  case 14:
#line 179 "mpsl.y" /* yacc.c:1646  */
    {
					/* subroutine definition,
					   with arguments */
					(yyval.ins) = INS2(L"ASSIGN", (yyvsp[-6].ins),
						INS1(L"LITERAL",
							mpsl_x((yyvsp[-1].ins), (yyvsp[-4].ins), 1)));
				}
#line 1949 "y.tab.c" /* yacc.c:1646  */
    break;

  case 15:
#line 188 "mpsl.y" /* yacc.c:1646  */
    {
					/* foreach construction */
					/* a block frame is created, the iterator
					   created as local, and the foreach executed */
					(yyval.ins) = INS1(L"BLKFRAME",
						INS2(L"MULTI",
							INS1(L"LOCAL", (yyvsp[-4].ins)),
							INS3(L"FOREACH", (yyvsp[-4].ins), (yyvsp[-2].ins), (yyvsp[0].ins))
						)
					);
				}
#line 1965 "y.tab.c" /* yacc.c:1646  */
    break;

  case 16:
#line 200 "mpsl.y" /* yacc.c:1646  */
    {
					compiler_warning("useless use of local in foreach loop");

					(yyval.ins) = INS1(L"BLKFRAME",
						INS2(L"MULTI",
							INS1(L"LOCAL", (yyvsp[-4].ins)),
							INS3(L"FOREACH", (yyvsp[-4].ins), (yyvsp[-2].ins), (yyvsp[0].ins))
						)
					);
				}
#line 1980 "y.tab.c" /* yacc.c:1646  */
    break;

  case 17:
#line 211 "mpsl.y" /* yacc.c:1646  */
    {
					/* block of instructions,
					   with local symbol table */
					(yyval.ins) = INS1(L"BLKFRAME", (yyvsp[-1].ins));
				}
#line 1990 "y.tab.c" /* yacc.c:1646  */
    break;

  case 18:
#line 217 "mpsl.y" /* yacc.c:1646  */
    {
					/* local symbol creation */
					(yyval.ins) = INS1(L"LOCAL", (yyvsp[-1].ins));
				}
#line 1999 "y.tab.c" /* yacc.c:1646  */
    break;

  case 19:
#line 222 "mpsl.y" /* yacc.c:1646  */
    {
					/* contraction; local symbol
					   creation and assignation */
					(yyval.ins) = INS2(L"MULTI",
						INS1(L"LOCAL",
							INS1(L"LITERAL", (yyvsp[-3].v))),
						INS2(L"ASSIGN",
							INS1(L"LITERAL", (yyvsp[-3].v)),(yyvsp[-1].ins))
						);
				}
#line 2014 "y.tab.c" /* yacc.c:1646  */
    break;

  case 20:
#line 232 "mpsl.y" /* yacc.c:1646  */
    {
					/* global symbol creation */
					(yyval.ins) = INS1(L"GLOBAL", (yyvsp[-1].ins));
				}
#line 2023 "y.tab.c" /* yacc.c:1646  */
    break;

  case 21:
#line 237 "mpsl.y" /* yacc.c:1646  */
    {
					/* contraction; global symbol
					   creation and assignation */
					(yyval.ins) = INS2(L"MULTI",
						INS1(L"GLOBAL",
							INS1(L"LITERAL", (yyvsp[-3].v))),
						INS2(L"ASSIGN",
							INS1(L"LITERAL", (yyvsp[-3].v)),(yyvsp[-1].ins))
						);
				}
#line 2038 "y.tab.c" /* yacc.c:1646  */
    break;

  case 22:
#line 247 "mpsl.y" /* yacc.c:1646  */
    {
					/* break (exit from loop) */
					(yyval.ins) = INS0(L"BREAK");
				}
#line 2047 "y.tab.c" /* yacc.c:1646  */
    break;

  case 23:
#line 251 "mpsl.y" /* yacc.c:1646  */
    {
					/* return from subroutine */
					(yyval.ins) = INS1(L"RETURN", (yyvsp[-1].ins));
				}
#line 2056 "y.tab.c" /* yacc.c:1646  */
    break;

  case 24:
#line 255 "mpsl.y" /* yacc.c:1646  */
    {
					/* return from subroutine (void) */
					(yyval.ins) = INS0(L"RETURN");
				}
#line 2065 "y.tab.c" /* yacc.c:1646  */
    break;

  case 25:
#line 262 "mpsl.y" /* yacc.c:1646  */
    { (yyval.ins) = (yyvsp[0].ins); }
#line 2071 "y.tab.c" /* yacc.c:1646  */
    break;

  case 26:
#line 263 "mpsl.y" /* yacc.c:1646  */
    {
					/* sequence of instructions */
					(yyval.ins) = INS2(L"MULTI", (yyvsp[-1].ins), (yyvsp[0].ins));
				}
#line 2080 "y.tab.c" /* yacc.c:1646  */
    break;

  case 27:
#line 270 "mpsl.y" /* yacc.c:1646  */
    {
					(yyval.ins) = INS1(L"LIST", (yyvsp[0].ins));
				}
#line 2088 "y.tab.c" /* yacc.c:1646  */
    break;

  case 28:
#line 273 "mpsl.y" /* yacc.c:1646  */
    {
					/* build list from list of
					   instructions */
					(yyval.ins) = INS2(L"LIST", (yyvsp[0].ins), (yyvsp[-2].ins));
				}
#line 2098 "y.tab.c" /* yacc.c:1646  */
    break;

  case 29:
#line 281 "mpsl.y" /* yacc.c:1646  */
    {
					(yyval.ins) = INS1(L"LIST",
						INS1(L"LITERAL", (yyvsp[0].v)));
				}
#line 2107 "y.tab.c" /* yacc.c:1646  */
    break;

  case 30:
#line 285 "mpsl.y" /* yacc.c:1646  */
    {
					/* comma-separated list of symbols */
					(yyval.ins) = INS2(L"LIST",
						INS1(L"LITERAL", (yyvsp[0].v)), (yyvsp[-2].ins));
				}
#line 2117 "y.tab.c" /* yacc.c:1646  */
    break;

  case 31:
#line 293 "mpsl.y" /* yacc.c:1646  */
    {
                (yyval.ins) = INS2(L"HASH", (yyvsp[-2].ins), (yyvsp[0].ins));
                }
#line 2125 "y.tab.c" /* yacc.c:1646  */
    break;

  case 32:
#line 296 "mpsl.y" /* yacc.c:1646  */
    {
                (yyval.ins) = INS2(L"HASH", INS1(L"LITERAL", (yyvsp[-2].v)), (yyvsp[0].ins));
                }
#line 2133 "y.tab.c" /* yacc.c:1646  */
    break;

  case 33:
#line 300 "mpsl.y" /* yacc.c:1646  */
    {
                    /* build hash from list of
                       instructions */
                    (yyval.ins) = INS3(L"HASH", (yyvsp[-2].ins), (yyvsp[0].ins), (yyvsp[-4].ins));
                }
#line 2143 "y.tab.c" /* yacc.c:1646  */
    break;

  case 34:
#line 306 "mpsl.y" /* yacc.c:1646  */
    {
                    /* build hash from list of
                       instructions */
                    (yyval.ins) = INS3(L"HASH", INS1(L"LITERAL", (yyvsp[-2].v)), (yyvsp[0].ins), (yyvsp[-4].ins));
                }
#line 2153 "y.tab.c" /* yacc.c:1646  */
    break;

  case 35:
#line 314 "mpsl.y" /* yacc.c:1646  */
    {
					(yyval.ins) = INS1(L"LIST",
						INS1(L"LITERAL", (yyvsp[0].v)));
				}
#line 2162 "y.tab.c" /* yacc.c:1646  */
    break;

  case 36:
#line 318 "mpsl.y" /* yacc.c:1646  */
    {
					/* a.5 compound symbol */
					(yyval.ins) = INS2(L"LIST",
						INS1(L"LITERAL", (yyvsp[0].v)), (yyvsp[-2].ins));
				}
#line 2172 "y.tab.c" /* yacc.c:1646  */
    break;

  case 37:
#line 323 "mpsl.y" /* yacc.c:1646  */
    {
					/* a.b compound symbol */
					(yyval.ins) = INS2(L"LIST",
						INS1(L"LITERAL", (yyvsp[0].v)), (yyvsp[-2].ins));
				}
#line 2182 "y.tab.c" /* yacc.c:1646  */
    break;

  case 38:
#line 328 "mpsl.y" /* yacc.c:1646  */
    {
					/* a["b"] or a[5] compound symbol */
					(yyval.ins) = INS2(L"LIST", (yyvsp[-1].ins), (yyvsp[-3].ins));
				}
#line 2191 "y.tab.c" /* yacc.c:1646  */
    break;

  case 39:
#line 335 "mpsl.y" /* yacc.c:1646  */
    {
					/* literal integer */
					(yyval.ins) = INS1(L"LITERAL", (yyvsp[0].v));
				}
#line 2200 "y.tab.c" /* yacc.c:1646  */
    break;

  case 40:
#line 339 "mpsl.y" /* yacc.c:1646  */
    {
					/* literal string */
					(yyval.ins) = INS1(L"LITERAL", (yyvsp[0].v));
				}
#line 2209 "y.tab.c" /* yacc.c:1646  */
    break;

  case 41:
#line 343 "mpsl.y" /* yacc.c:1646  */
    {
					/* literal real number */
					(yyval.ins) = INS1(L"LITERAL", (yyvsp[0].v));
				}
#line 2218 "y.tab.c" /* yacc.c:1646  */
    break;

  case 42:
#line 347 "mpsl.y" /* yacc.c:1646  */
    {
					/* compound symbol */
					(yyval.ins) = INS1(L"SYMVAL", (yyvsp[0].ins));
				}
#line 2227 "y.tab.c" /* yacc.c:1646  */
    break;

  case 43:
#line 351 "mpsl.y" /* yacc.c:1646  */
    {
					/* NULL value */
					(yyval.ins) = INS1(L"LITERAL", NULL);
				}
#line 2236 "y.tab.c" /* yacc.c:1646  */
    break;

  case 44:
#line 356 "mpsl.y" /* yacc.c:1646  */
    {
					/* unary minus */
					(yyval.ins) = INS1(L"UMINUS", (yyvsp[0].ins));
				}
#line 2245 "y.tab.c" /* yacc.c:1646  */
    break;

  case 45:
#line 362 "mpsl.y" /* yacc.c:1646  */
    { (yyval.ins) = INS2(L"ADD", (yyvsp[-2].ins), (yyvsp[0].ins)); }
#line 2251 "y.tab.c" /* yacc.c:1646  */
    break;

  case 46:
#line 363 "mpsl.y" /* yacc.c:1646  */
    { (yyval.ins) = INS2(L"SUB", (yyvsp[-2].ins), (yyvsp[0].ins)); }
#line 2257 "y.tab.c" /* yacc.c:1646  */
    break;

  case 47:
#line 364 "mpsl.y" /* yacc.c:1646  */
    { (yyval.ins) = INS2(L"MUL", (yyvsp[-2].ins), (yyvsp[0].ins)); }
#line 2263 "y.tab.c" /* yacc.c:1646  */
    break;

  case 48:
#line 365 "mpsl.y" /* yacc.c:1646  */
    { (yyval.ins) = INS2(L"DIV", (yyvsp[-2].ins), (yyvsp[0].ins)); }
#line 2269 "y.tab.c" /* yacc.c:1646  */
    break;

  case 49:
#line 366 "mpsl.y" /* yacc.c:1646  */
    { (yyval.ins) = INS2(L"MOD", (yyvsp[-2].ins), (yyvsp[0].ins)); }
#line 2275 "y.tab.c" /* yacc.c:1646  */
    break;

  case 50:
#line 367 "mpsl.y" /* yacc.c:1646  */
    { (yyval.ins) = INS2(L"POW", (yyvsp[-2].ins), (yyvsp[0].ins)); }
#line 2281 "y.tab.c" /* yacc.c:1646  */
    break;

  case 51:
#line 370 "mpsl.y" /* yacc.c:1646  */
    { (yyval.ins) = INS2(L"BITAND", (yyvsp[-2].ins), (yyvsp[0].ins)); }
#line 2287 "y.tab.c" /* yacc.c:1646  */
    break;

  case 52:
#line 371 "mpsl.y" /* yacc.c:1646  */
    { (yyval.ins) = INS2(L"BITOR", (yyvsp[-2].ins), (yyvsp[0].ins)); }
#line 2293 "y.tab.c" /* yacc.c:1646  */
    break;

  case 53:
#line 372 "mpsl.y" /* yacc.c:1646  */
    { (yyval.ins) = INS2(L"BITXOR", (yyvsp[-2].ins), (yyvsp[0].ins)); }
#line 2299 "y.tab.c" /* yacc.c:1646  */
    break;

  case 54:
#line 373 "mpsl.y" /* yacc.c:1646  */
    { (yyval.ins) = INS2(L"SHL", (yyvsp[-2].ins), (yyvsp[0].ins)); }
#line 2305 "y.tab.c" /* yacc.c:1646  */
    break;

  case 55:
#line 374 "mpsl.y" /* yacc.c:1646  */
    { (yyval.ins) = INS2(L"SHR", (yyvsp[-2].ins), (yyvsp[0].ins)); }
#line 2311 "y.tab.c" /* yacc.c:1646  */
    break;

  case 56:
#line 377 "mpsl.y" /* yacc.c:1646  */
    { (yyval.ins) = INS2(L"ASSIGN", (yyvsp[0].ins),
					INS2(L"ADD",
						INS1(L"SYMVAL", (yyvsp[0].ins)),
						INS1(L"LITERAL", MPDM_I(1))
						)
					);
				}
#line 2323 "y.tab.c" /* yacc.c:1646  */
    break;

  case 57:
#line 384 "mpsl.y" /* yacc.c:1646  */
    { (yyval.ins) = INS2(L"ASSIGN", (yyvsp[0].ins),
					INS2(L"SUB",
						INS1(L"SYMVAL", (yyvsp[0].ins)),
						INS1(L"LITERAL", MPDM_I(1))
						)
					);
				}
#line 2335 "y.tab.c" /* yacc.c:1646  */
    break;

  case 58:
#line 393 "mpsl.y" /* yacc.c:1646  */
    { (yyval.ins) = INS2(L"IMULTI",
					INS1(L"SYMVAL", (yyvsp[-1].ins)),
					INS2(L"ASSIGN", (yyvsp[-1].ins),
						INS2(L"ADD",
							INS1(L"SYMVAL", (yyvsp[-1].ins)),
							INS1(L"LITERAL", MPDM_I(1))
							)
						)
					);
				}
#line 2350 "y.tab.c" /* yacc.c:1646  */
    break;

  case 59:
#line 403 "mpsl.y" /* yacc.c:1646  */
    { (yyval.ins) = INS2(L"IMULTI",
					INS1(L"SYMVAL", (yyvsp[-1].ins)),
					INS2(L"ASSIGN", (yyvsp[-1].ins),
						INS2(L"SUB",
							INS1(L"SYMVAL", (yyvsp[-1].ins)),
							INS1(L"LITERAL", MPDM_I(1))
							)
						)
					);
				}
#line 2365 "y.tab.c" /* yacc.c:1646  */
    break;

  case 60:
#line 415 "mpsl.y" /* yacc.c:1646  */
    { (yyval.ins) = INS2(L"ASSIGN", (yyvsp[-2].ins),
					INS2(L"ADD",
						INS1(L"SYMVAL", (yyvsp[-2].ins)),
						(yyvsp[0].ins))
					);
				}
#line 2376 "y.tab.c" /* yacc.c:1646  */
    break;

  case 61:
#line 421 "mpsl.y" /* yacc.c:1646  */
    { (yyval.ins) = INS2(L"ASSIGN", (yyvsp[-2].ins),
					INS2(L"SUB",
						INS1(L"SYMVAL", (yyvsp[-2].ins)),
						(yyvsp[0].ins))
					);
				}
#line 2387 "y.tab.c" /* yacc.c:1646  */
    break;

  case 62:
#line 427 "mpsl.y" /* yacc.c:1646  */
    { (yyval.ins) = INS2(L"ASSIGN", (yyvsp[-2].ins),
					INS2(L"MUL",
						INS1(L"SYMVAL", (yyvsp[-2].ins)),
						(yyvsp[0].ins))
					);
				}
#line 2398 "y.tab.c" /* yacc.c:1646  */
    break;

  case 63:
#line 433 "mpsl.y" /* yacc.c:1646  */
    { (yyval.ins) = INS2(L"ASSIGN", (yyvsp[-2].ins),
					INS2(L"DIV",
						INS1(L"SYMVAL", (yyvsp[-2].ins)),
						(yyvsp[0].ins))
					);
				}
#line 2409 "y.tab.c" /* yacc.c:1646  */
    break;

  case 64:
#line 439 "mpsl.y" /* yacc.c:1646  */
    { (yyval.ins) = INS2(L"ASSIGN", (yyvsp[-2].ins),
					INS2(L"MOD",
						INS1(L"SYMVAL", (yyvsp[-2].ins)),
						(yyvsp[0].ins))
					);
				}
#line 2420 "y.tab.c" /* yacc.c:1646  */
    break;

  case 65:
#line 445 "mpsl.y" /* yacc.c:1646  */
    { (yyval.ins) = INS2(L"ASSIGN", (yyvsp[-2].ins),
					INS2(L"BITAND",
						INS1(L"SYMVAL", (yyvsp[-2].ins)),
						(yyvsp[0].ins))
					);
				}
#line 2431 "y.tab.c" /* yacc.c:1646  */
    break;

  case 66:
#line 451 "mpsl.y" /* yacc.c:1646  */
    { (yyval.ins) = INS2(L"ASSIGN", (yyvsp[-2].ins),
					INS2(L"BITOR",
						INS1(L"SYMVAL", (yyvsp[-2].ins)),
						(yyvsp[0].ins))
					);
				}
#line 2442 "y.tab.c" /* yacc.c:1646  */
    break;

  case 67:
#line 457 "mpsl.y" /* yacc.c:1646  */
    { (yyval.ins) = INS2(L"ASSIGN", (yyvsp[-2].ins),
					INS2(L"BITXOR",
						INS1(L"SYMVAL", (yyvsp[-2].ins)),
						(yyvsp[0].ins))
					);
				}
#line 2453 "y.tab.c" /* yacc.c:1646  */
    break;

  case 68:
#line 463 "mpsl.y" /* yacc.c:1646  */
    { (yyval.ins) = INS2(L"ASSIGN", (yyvsp[-2].ins),
					INS2(L"SHL",
						INS1(L"SYMVAL", (yyvsp[-2].ins)),
						(yyvsp[0].ins))
					);
				}
#line 2464 "y.tab.c" /* yacc.c:1646  */
    break;

  case 69:
#line 469 "mpsl.y" /* yacc.c:1646  */
    { (yyval.ins) = INS2(L"ASSIGN", (yyvsp[-2].ins),
					INS2(L"SHR",
						INS1(L"SYMVAL", (yyvsp[-2].ins)),
						(yyvsp[0].ins))
					);
				}
#line 2475 "y.tab.c" /* yacc.c:1646  */
    break;

  case 70:
#line 476 "mpsl.y" /* yacc.c:1646  */
    { (yyval.ins) = INS2(L"ASSIGN", (yyvsp[-2].ins),
					INS2(L"OR",
						INS1(L"SYMVAL", (yyvsp[-2].ins)),
						(yyvsp[0].ins))
					);
				}
#line 2486 "y.tab.c" /* yacc.c:1646  */
    break;

  case 71:
#line 482 "mpsl.y" /* yacc.c:1646  */
    { (yyval.ins) = INS2(L"ASSIGN", (yyvsp[-2].ins),
					INS2(L"JOIN",
						INS1(L"SYMVAL", (yyvsp[-2].ins)),
						(yyvsp[0].ins))
					);
				}
#line 2497 "y.tab.c" /* yacc.c:1646  */
    break;

  case 72:
#line 489 "mpsl.y" /* yacc.c:1646  */
    {
					/* boolean not */
					(yyval.ins) = INS1(L"NOT", (yyvsp[0].ins));
				}
#line 2506 "y.tab.c" /* yacc.c:1646  */
    break;

  case 73:
#line 493 "mpsl.y" /* yacc.c:1646  */
    {
					/* bool less than */
					(yyval.ins) = INS2(L"NUMLT", (yyvsp[-2].ins), (yyvsp[0].ins));
				}
#line 2515 "y.tab.c" /* yacc.c:1646  */
    break;

  case 74:
#line 497 "mpsl.y" /* yacc.c:1646  */
    {
					/* bool greater than */
					(yyval.ins) = INS2(L"NUMGT", (yyvsp[-2].ins), (yyvsp[0].ins));
				}
#line 2524 "y.tab.c" /* yacc.c:1646  */
    break;

  case 75:
#line 501 "mpsl.y" /* yacc.c:1646  */
    {
					/* bool less or equal than */
					(yyval.ins) = INS2(L"NUMLE", (yyvsp[-2].ins), (yyvsp[0].ins));
				}
#line 2533 "y.tab.c" /* yacc.c:1646  */
    break;

  case 76:
#line 505 "mpsl.y" /* yacc.c:1646  */
    {
					/* bool greater or equal than */
					(yyval.ins) = INS2(L"NUMGE", (yyvsp[-2].ins), (yyvsp[0].ins));
				}
#line 2542 "y.tab.c" /* yacc.c:1646  */
    break;

  case 77:
#line 509 "mpsl.y" /* yacc.c:1646  */
    {
					/* bool numeric equal */
					(yyval.ins) = INS2(L"NUMEQ", (yyvsp[-2].ins), (yyvsp[0].ins));
				}
#line 2551 "y.tab.c" /* yacc.c:1646  */
    break;

  case 78:
#line 513 "mpsl.y" /* yacc.c:1646  */
    {
					/* bool numeric non-equal */
					(yyval.ins) = INS1(L"NOT",
						INS2(L"NUMEQ", (yyvsp[-2].ins), (yyvsp[0].ins)));
				}
#line 2561 "y.tab.c" /* yacc.c:1646  */
    break;

  case 79:
#line 519 "mpsl.y" /* yacc.c:1646  */
    {
					/* join */
					(yyval.ins) = INS2(L"JOIN", (yyvsp[-2].ins), (yyvsp[0].ins));
				}
#line 2570 "y.tab.c" /* yacc.c:1646  */
    break;

  case 80:
#line 523 "mpsl.y" /* yacc.c:1646  */
    {
					/* bool string equal */
					(yyval.ins) = INS2(L"STREQ", (yyvsp[-2].ins), (yyvsp[0].ins));
				}
#line 2579 "y.tab.c" /* yacc.c:1646  */
    break;

  case 81:
#line 527 "mpsl.y" /* yacc.c:1646  */
    {
					/* bool string non-equal */
					(yyval.ins) = INS1(L"NOT",
						INS2(L"STREQ", (yyvsp[-2].ins), (yyvsp[0].ins)));
				}
#line 2589 "y.tab.c" /* yacc.c:1646  */
    break;

  case 82:
#line 533 "mpsl.y" /* yacc.c:1646  */
    {
					/* boolean and */
					(yyval.ins) = INS2(L"AND", (yyvsp[-2].ins), (yyvsp[0].ins));
				}
#line 2598 "y.tab.c" /* yacc.c:1646  */
    break;

  case 83:
#line 537 "mpsl.y" /* yacc.c:1646  */
    {
					/* boolean or */
					(yyval.ins) = INS2(L"OR", (yyvsp[-2].ins), (yyvsp[0].ins));
				}
#line 2607 "y.tab.c" /* yacc.c:1646  */
    break;

  case 84:
#line 542 "mpsl.y" /* yacc.c:1646  */
    {
					/* anonymous subroutine (without args) */
					(yyval.ins) = INS1(L"LITERAL", mpsl_x((yyvsp[-1].ins), NULL, 0));
				}
#line 2616 "y.tab.c" /* yacc.c:1646  */
    break;

  case 85:
#line 548 "mpsl.y" /* yacc.c:1646  */
    {
					/* anonymous subroutine (with args) */
					(yyval.ins) = INS1(L"LITERAL", mpsl_x((yyvsp[-1].ins), (yyvsp[-4].ins), 0));
				}
#line 2625 "y.tab.c" /* yacc.c:1646  */
    break;

  case 86:
#line 553 "mpsl.y" /* yacc.c:1646  */
    {
					/* parenthesized expression */
					(yyval.ins) = (yyvsp[-1].ins);
				}
#line 2634 "y.tab.c" /* yacc.c:1646  */
    break;

  case 87:
#line 558 "mpsl.y" /* yacc.c:1646  */
    {
					/* empty list */
					(yyval.ins) = INS1(L"LITERAL", MPDM_A(0));
				}
#line 2643 "y.tab.c" /* yacc.c:1646  */
    break;

  case 88:
#line 562 "mpsl.y" /* yacc.c:1646  */
    {
					/* non-empty list */
					(yyval.ins) = (yyvsp[-1].ins);
				}
#line 2652 "y.tab.c" /* yacc.c:1646  */
    break;

  case 89:
#line 567 "mpsl.y" /* yacc.c:1646  */
    {
					/* build range from expressions */
					(yyval.ins) = INS2(L"RANGE", (yyvsp[-3].ins), (yyvsp[-1].ins));
				}
#line 2661 "y.tab.c" /* yacc.c:1646  */
    break;

  case 90:
#line 572 "mpsl.y" /* yacc.c:1646  */
    {
					/* empty hash */
					(yyval.ins) = INS1(L"LITERAL", MPDM_H(0));
				}
#line 2670 "y.tab.c" /* yacc.c:1646  */
    break;

  case 91:
#line 576 "mpsl.y" /* yacc.c:1646  */
    {
					/* non-empty hash */
					(yyval.ins) = (yyvsp[-1].ins);
				}
#line 2679 "y.tab.c" /* yacc.c:1646  */
    break;

  case 92:
#line 581 "mpsl.y" /* yacc.c:1646  */
    {
					/* function call (without args) */
					(yyval.ins) = INS1(L"EXECSYM", (yyvsp[-2].ins));
				}
#line 2688 "y.tab.c" /* yacc.c:1646  */
    break;

  case 93:
#line 585 "mpsl.y" /* yacc.c:1646  */
    {
					/* function call (with args) */
					(yyval.ins) = INS2(L"EXECSYM", (yyvsp[-3].ins), (yyvsp[-1].ins));
				}
#line 2697 "y.tab.c" /* yacc.c:1646  */
    break;

  case 94:
#line 589 "mpsl.y" /* yacc.c:1646  */
    {
					/* function call with only an inverse argument */
					(yyval.ins) = INS2(L"METHOD", (yyvsp[-2].ins), INS1(L"ILIST", (yyvsp[-4].ins)));
				}
#line 2706 "y.tab.c" /* yacc.c:1646  */
    break;

  case 95:
#line 593 "mpsl.y" /* yacc.c:1646  */
    {
					/* function call with inverse argument and other ones */
					(yyval.ins) = INS2(L"METHOD", (yyvsp[-3].ins), INS2(L"ILIST", (yyvsp[-5].ins), (yyvsp[-1].ins)));
				}
#line 2715 "y.tab.c" /* yacc.c:1646  */
    break;

  case 96:
#line 597 "mpsl.y" /* yacc.c:1646  */
    {
					/* function call as a new thread (without args) */
					(yyval.ins) = INS1(L"THREADSYM", (yyvsp[-2].ins));
				}
#line 2724 "y.tab.c" /* yacc.c:1646  */
    break;

  case 97:
#line 601 "mpsl.y" /* yacc.c:1646  */
    {
					/* function call as a new thread (with args) */
					(yyval.ins) = INS2(L"THREADSYM", (yyvsp[-3].ins), (yyvsp[-1].ins));
				}
#line 2733 "y.tab.c" /* yacc.c:1646  */
    break;

  case 98:
#line 605 "mpsl.y" /* yacc.c:1646  */
    {
					/* simple assignation */
					(yyval.ins) = INS2(L"ASSIGN", (yyvsp[-2].ins), (yyvsp[0].ins));
				}
#line 2742 "y.tab.c" /* yacc.c:1646  */
    break;


#line 2746 "y.tab.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 612 "mpsl.y" /* yacc.c:1906  */


void yyerror(char *s)
{
    char tmp[1024];

    snprintf(tmp, sizeof(tmp), "%s in %s, line %d",
             s, mpsl_filename, mpsl_line + 1);

    mpsl_error(MPDM_MBS(tmp));
}


static FILE *inc_fopen(const char *filename, mpdm_t inc)
/* loads filename, searching in INC if not directly accesible */
{
    FILE *f = NULL;
    char tmp[1024];
    int n;

    /* loop through INC, prepending each path
       to the filename */
    for (n = 0; n < mpdm_size(inc); n++) {
        mpdm_t v = mpdm_aget(inc, n);

        v = mpdm_ref(MPDM_2MBS(v->data));
        snprintf(tmp, sizeof(tmp), "%s/%s", (char *) v->data, filename);
        mpdm_unref(v);

        if ((f = fopen(tmp, "r")) != NULL)
            break;
    }

    return f;
}


static mpdm_t do_parse(const char *filename, wchar_t * code, FILE * file)
/* calls yyparse() after doing some initialisations, and returns
   the compiled code as an executable value */
{
    mpdm_t v;
    mpdm_t x = NULL;

    /* first line */
    mpsl_line = 0;

    /* reset last bytecode */
    mpsl_bytecode = NULL;

    /* set globals */
    mpsl_next_char = code;
    mpsl_file = file;

    if (mpsl_filename != NULL)
        free(mpsl_filename);

    mpsl_filename = strdup(filename);

    /* cache some values */
    v = mpdm_hget_s(mpdm_root(), L"MPSL");
    mpsl_opcodes = mpdm_hget_s(v, L"OPCODE");
    mpsl_lc = mpdm_hget_s(v, L"LC");

    /* compile! */
    if (yyparse() == 0 && mpsl_bytecode != NULL)
        x = mpsl_x(mpsl_bytecode, NULL, 1);

    /* clean back cached values */
    mpsl_opcodes = NULL;
    mpsl_lc = NULL;

    return x;
}


/**
 * mpsl_compile - Compiles a string of MPSL code.
 * @code: A value containing a string of MPSL code
 *
 * Compiles a string of MPSL code and returns an mpdm value executable
 * by mpdm_exec(). If there is a syntax (or other type) error, NULL
 * is returned instead.
 */
mpdm_t mpsl_compile(mpdm_t code)
{
    mpdm_t x = NULL;

    mpdm_ref(code);
    x = do_parse("<INLINE>", (wchar_t *) code->data, NULL);
    mpdm_unref(code);

    return x;
}


/**
 * mpsl_compile_file - Compiles a file of MPSL code.
 * @file: File stream or file name.
 * @inc: search path for source files.
 *
 * Compiles a source file of MPSL code and returns an mpdm value
 * executable by mpdm_exec(). If @file is an MPSL file descriptor,
 * it's read as is and compiled; otherwise, it's assumed to be a
 * file name, that will be searched for in any of the paths defined
 * in the @inc array. If the file cannot be found
 * or there is any other error, NULL is returned instead.
 */
mpdm_t mpsl_compile_file(mpdm_t file, mpdm_t inc)
{
    mpdm_t w;
    mpdm_t x = NULL;
    FILE *f = NULL;
    const char *filename = NULL;

    mpdm_ref(file);
    mpdm_ref(inc);

    if ((f = mpdm_get_filehandle(file)) != NULL) {
        filename = "<FILE>";
        w = file;
    }
    else {
        mpdm_t v;

        /* it's a filename; open it */
        v = mpdm_ref(MPDM_2MBS(file->data));

        filename = v->data;

        if ((f = inc_fopen(filename, inc)) == NULL) {
            char tmp[128];

            snprintf(tmp, sizeof(tmp) - 1,
                     "File '%s' not found in INC", filename);
            mpsl_error(MPDM_MBS(tmp));
        }

        mpdm_unref(v);

        w = MPDM_F(f);
    }

    if (w != NULL) {
        x = do_parse(filename, NULL, f);
        mpdm_close(w);
    }

    mpdm_unref(inc);
    mpdm_unref(file);

    return x;
}


/**
 * mpsl_eval - Evaluates MSPL code.
 * @code: A value containing a string of MPSL code, or executable code
 * @args: optional arguments for @code
 * @ctxt: context for @code
 *
 * Evaluates a piece of code. The @code can be a string containing MPSL source
 * code (that will be compiled) or a direct executable value. If the compilation
 * or the execution gives an error, the ERROR variable will be set to a printable
 * value and NULL returned. Otherwise, the exit value from the code is returned
 * and ERROR set to NULL. The abort flag is reset on exit.
 */
mpdm_t mpsl_eval(mpdm_t code, mpdm_t args, mpdm_t ctxt)
{
    mpdm_t cs, r;

    /* reset error */
    mpsl_error(NULL);
    mpsl_abort = 0;

    mpdm_ref(code);

    /* if code is not executable, try to compile */
    if (!MPDM_IS_EXEC(code)) {
        mpdm_t c;

        /* get the eval cache */
        if ((c = mpdm_hget_s(mpdm_root(), L"__EVAL__")) == NULL)
            c = mpdm_hset_s(mpdm_root(), L"__EVAL__", MPDM_H(0));

        /* this code still not compiled? do it */
        if ((cs = mpdm_hget(c, code)) == NULL)
            cs = mpdm_hset(c, code, mpsl_compile(code));
    }
    else
        cs = code;

    /* execute, if possible */
    if (MPDM_IS_EXEC(cs))
        r = mpdm_exec(cs, args, ctxt);
    else
        r = NULL;

    /* reset the abort flag */
    mpsl_abort = 0;

    mpdm_unref(code);

    return r;
}
